#ifndef __CHCTRAVERSER_H
#define __CHCTRAVERSER_H

#include "RenderTraverser.h"


namespace CHCDemoEngine
{

/** Class implementing traversal using the CHC algorithm.
*/
class CHCTraverser: public RenderTraverser
{
public:
	CHCTraverser();

	virtual int GetType() const { return CHC; }

	
protected:

	/** Optimized query querying the node geometry instead
		of the bounding box
	*/
	OcclusionQuery *IssueOcclusionQueryWithGeometry(BvhNode *node);

	/** Traverses and renders the scene with the specified method
	*/
	virtual void Traverse();

	/// the query queue
	QueryQueue mQueryQueue;

};

}



#endif // __CHCTRAVERSER_H