#include "StopAndWaitTraverser.h"
#include "SceneEntity.h"


namespace CHCDemoEngine
{

using namespace std;



StopAndWaitTraverser::StopAndWaitTraverser()
{
}


void StopAndWaitTraverser::Traverse()
{
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		if (mBvh->IsWithinViewFrustum(node))
		{
			// if intersects near plane assume visible and don't issue test
			if (IntersectsNearPlane(node))
			{
				TraverseNode(node);
			}
			else
			{
				OcclusionQuery *query = IssueOcclusionQuery(node);

				waitTimer.Entry();
				bool visible = query->GetQueryResult() > mVisibilityThreshold;
				waitTimer.Exit();

				if (visible)
				{
					TraverseNode(node);
				}
				else
				{
					node->SetVisible(false);
					++ mStats.mNumQueryCulledNodes;
				}
				
				// update node's visited flag (could be interesting for the visualization)
				node->SetVisible(visible);		
			}
		}
		else
		{
			++ mStats.mNumFrustumCulledNodes;
		}	
	}
}

}